image: registry.gitlab.com/ratio-case-os/docker/python-ci:latest

stages:
  - build
  - test
  - docs
  - deploy
  - trigger

.case-main: &case-main
  only:
    refs:
      - main

install:build:
  stage: build
  script:
    - python-ci install
  artifacts:
    paths:
      - .venv/
    expire_in: 1 day

wheel:build:
  stage: build
  needs: [install:build]
  script:
    - python-ci build
  artifacts:
    paths:
      - dist/

pytest:test:
  stage: test
  needs: [install:build]
  script:
    - git config --global --add safe.directory /builds/ratio-case-os/python/raver
    - python-ci test
  coverage: '/(?i)total.*? (100(?:\.0+)?\%|[1-9]?\d(?:\.\d+)?\%)$/'
  artifacts:
    reports:
      coverage_report:
        coverage_format: cobertura
        path: ./.pytest_cache/coverage.xml
    paths:
      - docs/

black:test:
  stage: test
  allow_failure: true
  needs: [install:build]
  script:
    - python-ci lint

version:test:
  stage: test
  allow_failure: true
  needs: [install:build]
  script:
    - git config --global --add safe.directory /builds/ratio-case-os/python/raver
    - python-ci version

pages:
  stage: docs
  << : *case-main
  dependencies:
    - install:build
    - pytest:test
  script:
    - python-ci docs
    - mv ${CI_PROJECT_DIR}/docs/build/ public/
  artifacts:
    paths:
      - public

poetry:deploy:
  stage: deploy
  << : *case-main
  allow_failure: true
  dependencies:
    - install:build
    - wheel:build
  script:
    - python-ci publish $POETRY_PYPI_TOKEN

trigger:
  stage: trigger
  << : *case-main
  image: curlimages/curl
  script:
    - "curl -X POST --fail -F token=${SAVANNA_TRIGGER} -F ref=main https://gitlab.com/api/v4/projects/44900615/trigger/pipeline"
